/*
 * server.cpp
 *
 *  Created on: Nov 25, 2009
 *      Author: jaxy
 */

#include <Ice/Ice.h>
#include <CCU.h>
#include <CCUIS.h>

class Server : virtual public Ice::Application {
public:
  Server() {}

  int run(int argc, char* argv[]) {
      shutdownOnInterrupt();

      CraneI::_adapter = communicator()->createObjectAdapter("Crane");

      CraneI::_communicator = communicator();

      Ice::ObjectPtr object = new CraneI;
      CraneI::_adapter->add(object,communicator()->stringToIdentity("SimpleLogFile"));
      CraneI::_adapter->activate();

      cout << "******************************************************" << endl;
      cout << "*              shutting down with CTRL-C             *" << endl;
      cout << "******************************************************" << endl;

      communicator()->waitForShutdown();
      if (interrupted()) {
    	  cerr << "\n" << endl;
    	  cerr << "******************************************************" << endl;
    	  cerr << "*" << appName() << ": received signal, shutting down. *" << endl;
    	  cerr << "******************************************************" << endl;
      }
    return 0;
  }
};

int main(int argc, char* argv[]) {
  Server s;
  return s.main(argc,argv);
}
